package org.jeecg.modules.underonline.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.apache.commons.lang.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.config.mybatis.ThreadLocalDataHelper;
import org.jeecg.modules.device.entity.BuDevice;
import org.jeecg.modules.device.service.IBuDeviceService;
import org.jeecg.modules.energy.entity.BuElectric;
import org.jeecg.modules.sensor.entity.BuSensor;
import org.jeecg.modules.sensor.entity.BuSensorType;
import org.jeecg.modules.sensor.service.IBuSensorService;
import org.jeecg.modules.sensor.service.IBuSensorTypeService;
import org.jeecg.modules.underonline.entity.UnderOnline;
import org.jeecg.modules.underonline.service.IUnderOnlineService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: under_online
 * @Author: jeecg-boot
 * @Date:   2025-03-03
 * @Version: V1.0
 */
@Api(tags="under_online")
@RestController
@RequestMapping("/energy/underOnline")
@Slf4j
public class UnderOnlineController extends JeecgController<UnderOnline, IUnderOnlineService> {
	@Autowired
	private IUnderOnlineService underOnlineService;

	 @Autowired
	 private IBuSensorService buSensorService;
	 @Autowired
	 private IBuDeviceService buDeviceService;
	 @Autowired
	 private IBuSensorTypeService buSensorTypeService;

	/**
	 * 分页列表查询
	 *
	 * @param underOnline
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "under_online-分页列表查询")
	@ApiOperation(value="under_online-分页列表查询", notes="under_online-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<UnderOnline>> queryPageList(UnderOnline underOnline,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
//		QueryWrapper<UnderOnline> queryWrapper = QueryGenerator.initQueryWrapper(underOnline, req.getParameterMap());
//		Page<UnderOnline> page = new Page<UnderOnline>(pageNo, pageSize);
//		IPage<UnderOnline> pageList = underOnlineService.page(page, queryWrapper);
//		return Result.OK(pageList);


		BuDevice buDevice = buDeviceService.getById(underOnline.getDeviceId());
		System.out.println("设备编号:" + buDevice.getId());
		List<BuSensor> buSensors = buSensorService.getByCheckName(buDevice.getId(),"%PLC%");
		BuSensorType buSensorType = buSensorTypeService.getById(buSensors.get(0).getTypeId());
		String tableName = "";
		if(underOnline.getBeginTime()!=null){
			String substring = underOnline.getBeginTime().substring(0, underOnline.getBeginTime()
					.indexOf("-", underOnline.getBeginTime().indexOf("-") + 1)).replaceAll("-","");

			tableName = buSensorType.getTableHead() + "_history_" + substring;

		}
		ThreadLocalDataHelper.clear();
		ThreadLocalDataHelper.put("under_online",tableName);

		LambdaQueryWrapper<UnderOnline> queryWrapper = new LambdaQueryWrapper<>();

		if(underOnline.getDeviceId()!=null){
			LambdaQueryWrapper<BuSensor> lambdaQueryWrapper = new LambdaQueryWrapper<>();
			lambdaQueryWrapper.eq(BuSensor::getDeviceId,underOnline.getDeviceId());
			List<String> codeList = buSensorService.list(lambdaQueryWrapper).stream().map(BuSensor::getId).collect(Collectors.toList());
			queryWrapper.in(UnderOnline::getSensorId,codeList);
		}
		if(underOnline.getSensorId()!=null){
			queryWrapper.eq(UnderOnline::getSensorId,underOnline.getSensorId());
		}
		if (StringUtils.isNotBlank(underOnline.getBeginTime()) && StringUtils.isNotBlank(underOnline.getEndTime())){
			queryWrapper.between(UnderOnline::getCreateTime,underOnline.getBeginTime(),underOnline.getEndTime());
		}
		if (StringUtils.isNotBlank(underOnline.getInTime()) && StringUtils.isNotBlank(underOnline.getOutTime())){
			queryWrapper.between(UnderOnline::getCreateTime,underOnline.getInTime(),underOnline.getOutTime());
		}

		queryWrapper.orderByDesc(UnderOnline::getCreateTime);
		Page<UnderOnline> page = new Page<UnderOnline>(pageNo, pageSize);
		page.setOptimizeCountSql(false);
		IPage<UnderOnline> pageList = underOnlineService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 *   添加
	 *
	 * @param underOnline
	 * @return
	 */
	@AutoLog(value = "under_online-添加")
	@ApiOperation(value="under_online-添加", notes="under_online-添加")
	//@RequiresPermissions("org.jeecg.modules:under_online:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody UnderOnline underOnline) {
		underOnlineService.save(underOnline);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param underOnline
	 * @return
	 */
	@AutoLog(value = "under_online-编辑")
	@ApiOperation(value="under_online-编辑", notes="under_online-编辑")
	//@RequiresPermissions("org.jeecg.modules:under_online:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody UnderOnline underOnline) {
		underOnlineService.updateById(underOnline);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "under_online-通过id删除")
	@ApiOperation(value="under_online-通过id删除", notes="under_online-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:under_online:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		underOnlineService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "under_online-批量删除")
	@ApiOperation(value="under_online-批量删除", notes="under_online-批量删除")
	//@RequiresPermissions("org.jeecg.modules:under_online:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.underOnlineService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "under_online-通过id查询")
	@ApiOperation(value="under_online-通过id查询", notes="under_online-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<UnderOnline> queryById(@RequestParam(name="id",required=true) String id) {
		UnderOnline underOnline = underOnlineService.getById(id);
		if(underOnline==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(underOnline);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param underOnline
    */
    //@RequiresPermissions("org.jeecg.modules:under_online:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, UnderOnline underOnline) {
        return super.exportXls(request, underOnline, UnderOnline.class, "under_online");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("under_online:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, UnderOnline.class);
    }

}
